/* ------------------------------------------------------------------------ */
/*                                                                          */
/*  Copyright (C)                                                           */
/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 2 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful, but     */
/*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-    */
/*  ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General        */
/*  Public License for more details.                                        */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                   */
/*                                                                          */
/* ------------------------------------------------------------------------ */
/*  $Author: vogje02 $ $Revision: 1.3 $ $Date: 2002/07/09 10:55:30 $      */
/* ------------------------------------------------------------------------ */

#include "filespage.h"

extern COptions* options;

/////////////////////////////////////////////////////////////////////////////
// CFilesPage property page

CFilesPage::CFilesPage() : CPropertyPage(CFilesPage::IDD)
{
	//{{AFX_DATA_INIT(CFilesPage)
	m_hostedit = NULL;
	//}}AFX_DATA_INIT

	init = false;
}

CFilesPage::~CFilesPage()
{
}

void CFilesPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFilesPage)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP

	if( !init ) {
		init = true;
		SetOptions();
	}
}


BEGIN_MESSAGE_MAP(CFilesPage, CPropertyPage)
	//{{AFX_MSG_MAP(CFilesPage)
	ON_BN_CLICKED(IDC_CHECK6, OnCheck6)
	ON_EN_CHANGE(IDC_EDIT5, OnChangeEdit5)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_CHECK12, OnCheck12)
	ON_EN_CHANGE(IDC_EDIT6, OnChangeEdit6)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_CHECK_21, OnCheck21)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/**
 * This is setting all the widgets after an update
 * from the registry.
 */
void CFilesPage::SetOptions()
{
	if( init ) {

		// Input file
		if( options->infileB ) {
			CheckDlgButton( IDC_CHECK6, BST_CHECKED );
			GetDlgItem( IDC_BUTTON1 )->EnableWindow( TRUE );
			GetDlgItem( IDC_EDIT5 )->EnableWindow( TRUE );
			GetDlgItem( IDC_EDIT5 )->SetWindowText( options->infile );
		}

		// Output file
		if( options->outfileB ) {
			GetDlgItem( IDC_BUTTON3 )->EnableWindow( TRUE );
			GetDlgItem( IDC_EDIT6 )->EnableWindow( TRUE );
			GetDlgItem( IDC_RADIO1 )->EnableWindow( TRUE );
			GetDlgItem( IDC_RADIO2 )->EnableWindow( TRUE );
			GetDlgItem( IDC_RADIO3 )->EnableWindow( TRUE );
			GetDlgItem( IDC_RADIO4 )->EnableWindow( TRUE );
			GetDlgItem( IDC_CHECK_21 )->EnableWindow( TRUE );
			CheckDlgButton( IDC_CHECK12, BST_CHECKED );
			GetDlgItem( IDC_EDIT6 )->SetWindowText( options->outfile );
			CheckRadioButton( IDC_RADIO1, IDC_RADIO4, IDC_RADIO1 + options->outfileType );
		}
	}
}

/**
 * Set the status bar for the error message.
 */
void CFilesPage::SetStatusBar( CEdit* status, CEdit* hostedit )
{
	m_statusbar = status;
	m_hostedit = hostedit;
}

/**
 * Build the command from the widgets and fill in the 
 * options struct.
 */
void CFilesPage::BuildCommand()
{
	char *val = (LPTSTR)malloc( 256 );

	// Input file setting
	if( IsDlgButtonChecked( IDC_CHECK6 ) ) {

		GetDlgItem( IDC_EDIT5 )->GetWindowText( val, 256 );

		if( val && *val )
			strcpy( options->infile, val );
	}

	// Output file settings
	if( IsDlgButtonChecked( IDC_CHECK12 ) ) {

		GetDlgItem( IDC_EDIT6 )->GetWindowText( val, 256 );

		if( val && *val ) {   

			strcpy( options->outfile, val );

			switch( GetCheckedRadioButton( IDC_RADIO1, IDC_RADIO4 ) )
			{
			case IDC_RADIO1: 
				options->outfileType = OUTFILE_NORMAL;
				break;
			case IDC_RADIO2: 
				options->outfileType = OUTFILE_XML;
				break;
			case IDC_RADIO3: 
				options->outfileType = OUTFILE_GREP;
				break;
			case IDC_RADIO4: 
				options->outfileType = OUTFILE_ALL;
				break;
			}
		}
		if( IsDlgButtonChecked( IDC_CHECK_21 ) )
			options->outfileAppend = true;
	} else
		options->outfileAppend = false;

	char cmd[1024];
	options->GetCommand( cmd );
	m_statusbar->SetWindowText( cmd );
}

void CFilesPage::OnCheck6() 
{
	options->infileB = IsDlgButtonChecked( IDC_CHECK6 ) ? true : false;

	// Get the 'Input File' text field active/inactive
	if( GetDlgItem( IDC_EDIT5 )->IsWindowEnabled() ) {
		GetDlgItem( IDC_EDIT5 )->EnableWindow( FALSE );
		GetDlgItem( IDC_BUTTON3 )->EnableWindow( FALSE );
		m_hostedit->EnableWindow( TRUE );
	} else {
		GetDlgItem( IDC_EDIT5 )->EnableWindow( TRUE );
		GetDlgItem( IDC_BUTTON3 )->EnableWindow( TRUE );
		m_hostedit->EnableWindow( FALSE );
	}
	BuildCommand();	
}

void CFilesPage::OnChangeEdit5() 
{
	BuildCommand();	
}

void CFilesPage::OnCheck1() 
{
	BuildCommand();	
}

/**
 * Output file check box. If unchecked disable all 
 * widgets.
 */
void CFilesPage::OnCheck12() 
{
	options->outfileB = IsDlgButtonChecked( IDC_CHECK12 ) ? true : false;

	// Get the 'Port Range' text field active	
	if( GetDlgItem( IDC_EDIT6 )->IsWindowEnabled() ) {
		GetDlgItem( IDC_RADIO1 )->EnableWindow( FALSE );
		GetDlgItem( IDC_RADIO2 )->EnableWindow( FALSE );
		GetDlgItem( IDC_RADIO3 )->EnableWindow( FALSE );
		GetDlgItem( IDC_RADIO4 )->EnableWindow( FALSE );
		GetDlgItem( IDC_CHECK_21 )->EnableWindow( FALSE );
		GetDlgItem( IDC_EDIT6 )->EnableWindow( FALSE );
		GetDlgItem( IDC_BUTTON1)->EnableWindow( FALSE );
	} else {
		GetDlgItem( IDC_EDIT6 )->EnableWindow( TRUE );
		GetDlgItem( IDC_RADIO1 )->EnableWindow( TRUE );
		GetDlgItem( IDC_RADIO2 )->EnableWindow( TRUE );
		GetDlgItem( IDC_RADIO3 )->EnableWindow( TRUE );
		GetDlgItem( IDC_RADIO4 )->EnableWindow( TRUE );
		GetDlgItem( IDC_CHECK_21 )->EnableWindow( TRUE );
		GetDlgItem( IDC_BUTTON1)->EnableWindow( TRUE );
		CheckRadioButton( IDC_RADIO1, IDC_RADIO4, IDC_RADIO1 );
	}	
	BuildCommand();	
}

void CFilesPage::OnChangeEdit6() 
{
	BuildCommand();
}

void CFilesPage::OnButton1() 
{	
	static char BASED_CODE szFilter[] = "NMap LogFiles (*.log)|All Files (*.*)|*.*||";

	CFileDialog dlg( TRUE, "log", "*.log", OFN_LONGNAMES, szFilter, GetParent());
    
    if ( IDOK != dlg.DoModal() )
        return;	
	else {
		GetDlgItem( IDC_EDIT6 )->SetWindowText( dlg.GetPathName() );
		BuildCommand();
	}
}

void CFilesPage::OnButton2() 
{
	
}

void CFilesPage::SetVisible( CTabCtrl* parent )
{
	if( !IsWindow( m_hWnd ) ) {
		Create( IDD_DIALOG_FILES, parent );
	
		CRect rectParent;
		parent->GetWindowRect( rectParent );

		SetWindowPos( parent, 5, 25, rectParent.Width() - 10, rectParent.Height()-27, 
					  SWP_NOZORDER | SWP_NOACTIVATE );
	}
	ShowWindow( SW_SHOW );
}

void CFilesPage::OnButton3() 
{
	static char BASED_CODE szFilter[] = "NMap Input Files (*.nmap)|All Files (*.*)|*.*||";

	CFileDialog dlg( TRUE, "nmap", "*.nmap", OFN_LONGNAMES, szFilter, GetParent());
    
    if ( IDOK != dlg.DoModal() )
        return;	
	else {
		GetDlgItem( IDC_EDIT5 )->SetWindowText( dlg.GetPathName() );
		BuildCommand();
	}	
}

void CFilesPage::OnCheck21() 
{
	options->outfileAppend = IsDlgButtonChecked( IDC_CHECK_21 ) ? true : false;

	BuildCommand();	
}
