/* ------------------------------------------------------------------------ */
/*                                                                          */
/*  Copyright (C)                                                           */
/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 2 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful, but     */
/*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-    */
/*  ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General        */
/*  Public License for more details.                                        */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                   */
/*                                                                          */
/* ------------------------------------------------------------------------ */
/*  $Author: vogje02 $ $Revision: 1.2 $ $Date: 2002/07/09 10:55:30 $      */
/* ------------------------------------------------------------------------ */

#include "StdAfx.h"
#include "statusbar.h"
#include "resource.h"
#include "nmapwin.h"

// Dispatch interfaces referenced by this interface
#include <cc++\thread.h>

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/**
 * This implements the nmap listener. 
 *
 * It listens to the other end of the pipe opened by the nmap start process
 * and displays the incoming messages in the output window.
 */
class CListener : public Thread
{
public:
	CListener( CEdit* e, CButton* sa, CButton* so, CEdit* l, HANDLE p, 
			   CEdit* s, CStatic* b );

	void Run();

	int ReadFromPipe( char *buf, int bufsz );

private: 

	HANDLE pipe;
	char currHost[128];
	char currAddr[16];
	int  currItem;
	CEdit* m_status;
	CEdit* m_loglist;
	CEdit* m_hostedit;
	CButton* m_start;
	CButton* m_stop;
	CStatic* m_busyicon;
	HWND dialog;

	void InsertLogItem( char* text ); 
	void SetBusy();

	char* buffer;
};
