/* ------------------------------------------------------------------------ */
/*                                                                          */
/*  Copyright (C)                                                           */
/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 2 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful, but     */
/*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-    */
/*  ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General        */
/*  Public License for more details.                                        */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                   */
/*                                                                          */
/* ------------------------------------------------------------------------ */
/*  $Author: vogje02 $ $Revision: 1.8 $ $Date: 2002/07/28 17:13:20 $        */
/* ------------------------------------------------------------------------ */

#include "stdafx.h"
#include "nmapwin.h"
#include "nmapwinDlg.h"
#include "statlink.h"

extern char command[1024];
extern COptions* options;

/**
 * About dialog
 */
class CAboutDlg : public CDialog
{
public:
    CAboutDlg() : CDialog(IDD_ABOUTBOX) { }

    // Implementation
protected:

	CStaticLink m_textLink;        // static text
    CStaticLink m_iconLink;        // static icon

    //////////////////
    // Initialize dialog: subclass static controls
    virtual BOOL OnInitDialog() {
        m_textLink.SubclassDlgItem(IDC_URLTEXT, this);
        m_iconLink.SubclassDlgItem(IDC_URLICON, this);
        m_iconLink.m_link = _T( "http://mypage.bluewin.ch/vogje01/index.html" );
        return CDialog::OnInitDialog();
    }
};

/**
 * NMapWin main dialog
 */
CNmapwinDlg::CNmapwinDlg( CWnd* pParent ) : CDialog( CNmapwinDlg::IDD, pParent )
{
	// Initialization
	nmap_pid = 0;

	//{{AFX_DATA_INIT(CNmapwinDlg)
	//}}AFX_DATA_INIT

	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	// Set the default options
	options = new COptions();

	// Instantiate and initialize the background brush to black.
    m_pEditBkBrush = new CBrush(RGB(0, 0, 0));
}

void CNmapwinDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CNmapwinDlg)
	DDX_Control(pDX, IDC_TAB1, m_optionstab);
	DDX_Control(pDX, IDC_BUSY_ICON, m_busyicon);
	DDX_Control(pDX, IDC_EDIT1, m_invis);
	DDX_Control(pDX, IDC_EDIT11, m_date);
	DDX_Control(pDX, IDC_EDIT8, m_statusbar);
	DDX_Control(pDX, IDC_EDIT10, m_time);
	DDX_Control(pDX, IDC_EDIT2, m_loglist);
	DDX_Control(pDX, IDC_EDIT7, m_hostedit);
	DDX_Control(pDX, IDC_STOP, m_stop);
	DDX_Control(pDX, IDOK, m_start);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CNmapwinDlg, CDialog)
	//{{AFX_MSG_MAP(CNmapwinDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_BN_CLICKED(IDOK, OnScan)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_EN_CHANGE(IDC_EDIT1, OnChangeEdit1)
	ON_EN_CHANGE(IDC_EDIT7, OnChangeEdit7)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB1, OnSelchangeTab1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNmapwinDlg message handlers

BOOL CNmapwinDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Create the tab.
	m_optionstab.InsertItem( 0, "Scan" );
	m_optionstab.InsertItem( 1, "Discover" );
	m_optionstab.InsertItem( 2, "Options" );
	m_optionstab.InsertItem( 3, "Timing" );
	m_optionstab.InsertItem( 4, "Files" );
	m_optionstab.InsertItem( 5, "Service" );
	m_optionstab.InsertItem( 6, "Win32" );
	
	// Set the invisible statue line.
    m_scanPage.SetStatusBar( &m_invis );
	m_discoverPage.SetStatusBar( &m_invis );
	m_optionsPage.SetStatusBar( &m_invis );
	m_filesPage.SetStatusBar( &m_invis, &m_hostedit );
	m_timingPage.SetStatusBar( &m_invis );
	m_servicePage.SetStatusBar( &m_statusbar, &m_invis, &m_hostedit );
	m_windowsPage.SetStatusBar( &m_invis );

	// Distribute the options class
	m_scanPage.SetOptions();
	m_discoverPage.SetOptions();
	m_optionsPage.SetOptions();
	m_timingPage.SetOptions();
	m_filesPage.SetOptions();
	m_windowsPage.SetOptions();

	// The service page needs all other pages, as this
	// has to fill in the changed value read from the
	// registry.
	m_servicePage.SetPages( &m_scanPage, &m_discoverPage,
							&m_optionsPage, &m_timingPage,
							&m_filesPage, &m_windowsPage );

	CNmapwinApp* pApp= (CNmapwinApp*) AfxGetApp();
	freeicon= pApp->LoadIcon( IDI_ICON1 );
	busyicon= pApp->LoadIcon( IDI_ICON2 );
	
	m_busyicon.SetIcon( freeicon );

	CRect rectWindow, outputWindow;
	m_busyicon.GetWindowRect( rectWindow );
	m_statusbar.GetWindowRect( outputWindow );
	CalcWindowRect(rectWindow);
	CalcWindowRect(outputWindow);
	rectWindow.top = outputWindow.top;
	rectWindow.left = outputWindow.right - 4;
	rectWindow.right = rectWindow.left+20;
	rectWindow.bottom = rectWindow.top+20;
	m_busyicon.MoveWindow( rectWindow, true );
	
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Start message
	char tmp[40];
	sprintf( tmp, "NMapWin v%s", version );
	UpdateStatusBar( tmp );

	// Create the default table (scan)
	m_scanPage.SetVisible( &m_optionstab );

	m_hostedit.SetWindowText( options->hostName );

	return TRUE;  // return TRUE  unless you set the focus to a control
}

/**
 * Check for about box, otherwise transfer to framework
 */
void CNmapwinDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if( nID == 16 )
		CAboutDlg().DoModal();
	else
		CDialog::OnSysCommand(nID, lParam);
}

/**
 * On destroy, just distroy main dialog.
 */
void CNmapwinDlg::OnDestroy()
{
	WinHelp(0L, HELP_QUIT);
	CDialog::OnDestroy();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CNmapwinDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);

	} else

		CDialog::OnPaint();
}

// Stop the nmap process. We only stop the namp process. The 
// should get a SIG_BROKEN_PIPE and should stop as well.
void CNmapwinDlg::OnStop() 
{	
	TerminateProcess( Nmap_Proc.hProcess, 0 );
	UpdateStatusBar( "NMap process terminated!" ); 

	// Enable the buttons
	GetDlgItem( IDOK )->EnableWindow( TRUE );
	GetDlgItem( IDC_STOP )->EnableWindow( FALSE );	

	SetBusy( false );
}

void CNmapwinDlg::SetBusy( bool busy )
{
	if( busy ) {
		m_busyicon.SetIcon( busyicon );
		m_busyicon.RedrawWindow(NULL, NULL, RDW_UPDATENOW );
		GetDlgItem( IDC_EDIT7 )->EnableWindow( FALSE );
	} else {
		m_busyicon.SetIcon( freeicon );
		m_busyicon.RedrawWindow(NULL, NULL, RDW_UPDATENOW );
		GetDlgItem( IDC_EDIT7 )->EnableWindow( TRUE );
	}
}

/**
 * Update the status bar.
 */
void CNmapwinDlg::UpdateStatusBar( char* text )
{
	time_t ltime;
	struct tm tm;
	char stime[15];

	m_statusbar.SetWindowText( text ); 

	time( &ltime );
	tm = *localtime( &ltime );
	strftime( stime, 9, "%d/%m/%y", &tm) ;
	m_date.SetWindowText( stime );

	strftime( stime, 9, "%H:%M:%S", &tm) ;
	m_time.SetWindowText( stime );
}

/**
 * Build the nmap command options. Here we only have the host
 * selection box.
 */
char *CNmapwinDlg::BuildCommand() 
{
	static int command_size = 0;
	char *val = (LPTSTR)malloc( 60 ), text[255];

	*command = '\0';

	// Put the host selection into the options
    if( GetDlgItem( IDC_EDIT7 )->IsWindowEnabled() ) {
		
		GetDlgItem( IDC_EDIT7 )->GetWindowText( val, 40 );
	
		if( val && *val ) {
			strcpy( options->hostName, val );
		} else {
			strcpy( options->hostName, "" );
		}
	}

    // Get the options.
	options->GetCommand( command );

	// Update the status bar
	sprintf( text, "CMD: %s", command );
	UpdateStatusBar( text );

	if( options->winInterfaceB ) {
		OnScan();
		options->winInterfaceB = false;
	}

	return( command );
}

/**
 * Start the nmap process as background process.
 */
HANDLE CNmapwinDlg::ExecuteWin(char *command) 
{
	char text[255];
	char cmd[1024];

	sprintf( cmd, "nmap %s", command );

	GetStartupInfo( &Nmap_Start );

	// Insure that stdout/stderr for Nmap will go to our pipe
	Nmap_Start.hStdInput = GetStdHandle( STD_INPUT_HANDLE );
	Nmap_Start.hStdError = pipes[1];
	Nmap_Start.hStdOutput = pipes[1];
	Nmap_Start.dwFlags = STARTF_USESTDHANDLES;

	//Start up Nmap!
	if( !CreateProcess ( NULL, cmd, NULL, NULL, TRUE, CREATE_NO_WINDOW, NULL, NULL, &Nmap_Start,
						 &Nmap_Proc)) {
		sprintf( text, "Error%d: Failed to start Nmap process with command '%s'", GetLastError(), cmd );
		UpdateStatusBar(text ); 
		return ( HANDLE ) 0;
	} 

     // I don't care about the thread handle or the write pipe anymore
	 CloseHandle( Nmap_Proc.hThread );
     CloseHandle( pipes[1] );

	 return Nmap_Proc.hProcess;
}

/**
 * Check the command for syntax errors
 */
bool CNmapwinDlg::CheckCommand()
{
	if( !strcmp( options->hostName, "127.0.0.1" ) ) {
		::MessageBox( NULL, "NMapWin does not work on local loopback interfaces!", "NMapWin::CheckCommand", MB_ICONERROR );
		return false;
	}

	if( options->portRangeB && !strcmp( options->portRangeS, "" ) ) {
		::MessageBox( NULL, "Port range selected, but no range defined!", "NMapWin::CheckCommand", MB_ICONERROR );
		return false;
	}

	if( options->deviceB && !strcmp( options->deviceS, "" ) ) {
		::MessageBox( NULL, "Device name selected, but no device defined!", "NMapWin::CheckCommand", MB_ICONERROR );
		return false;
	}

	if( options->sAddressB && !strcmp( options->sAddressS, "" ) ) {
		::MessageBox( NULL, "Source address selected, but no address defined!", "NMapWin::CheckCommand", MB_ICONERROR );
		return false;
	}

	if( options->decoyB && !strcmp( options->decoyS, "" ) ) {
		::MessageBox( NULL, "Decoy host selected, but no host defined!", "NMapWin::CheckCommand", MB_ICONERROR );
		return false;
	}
	
	if( options->bounceB && !strcmp( options->bounceS, "" ) ) {
		::MessageBox( NULL, "FTP releay host selected, but no host defined!", "NMapWin::CheckCommand", MB_ICONERROR );
		return false;
	}

	if( options->portB && !strcmp( options->portS, "" ) ) {
		::MessageBox( NULL, "Source port selected, but no port defined!", "NMapWin::CheckCommand", MB_ICONERROR );
		return false;
	}

	if( !options->infileB && !strcmp( options->hostName, "" ) ) {

		::MessageBox( NULL, "Host field cannot be empty, when no input file is specified!", "NMapWin::CheckCommand", MB_ICONERROR );
		return false;
	}
	return true;
}

/**
 * Start button is pressed. Create a pipe and start the nmap
 * background process.
 */
void CNmapwinDlg::OnScan() 
{
	char command[1024];

	// Otherwise we are not really empty
	*command = '\0';
  
	if( GetDlgItem( IDOK )->IsWindowEnabled() ) {

		// Get the options.
		options->GetCommand( command );

		if( CheckCommand() ) {

			char tmp[1024];
			sprintf( tmp, "CMD: nmap %s", command );
			UpdateStatusBar( tmp );

			// Set the busy icon
			SetBusy( true );
		
			// To ensure pipe handles are inheritable */
			SECURITY_ATTRIBUTES PipeSA = { sizeof(SECURITY_ATTRIBUTES), NULL, TRUE };

			// Create our pipe for reading Nmap output
			if( !CreatePipe(&pipes[0], &pipes[1], &PipeSA, 8196 ) ) {

				UpdateStatusBar( "Error: Failed to create pipes!" ); 
				return;
			}

			listener = new CListener( &m_hostedit, &m_start, 
									  &m_stop, &m_loglist, (HANDLE)pipes[0], &m_statusbar,
									  &m_busyicon );
			// Start the listener
			listener->Start();

			// Start the nmap background process.
			HANDLE hProcess = ExecuteWin( command );

		}
	}
}

BEGIN_EVENTSINK_MAP(CNmapwinDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CNmapwinDlg)
//	ON_EVENT(CNmapwinDlg, IDC_SBARCTRL1, 1 /* PanelClick */, OnPanelClickSbarctrl1, VTS_DISPATCH)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CNmapwinDlg::OnChangeEdit1() 
{	
	// TODO: Add your control notification handler code here
	BuildCommand();	
}

void CNmapwinDlg::OnUpdateEdit1() 
{
	BuildCommand();	
}

void CNmapwinDlg::OnChangeEdit7() 
{	
	BuildCommand();	
}

/**
 * Stop the currently running nmap process
 */
void CNmapwinDlg::OnCancel() 
{
	TerminateProcess( Nmap_Proc.hProcess, 0 );

	CDialog::OnCancel();
}

/**
 * Start the help viewer
 */
void CNmapwinDlg::OnButton4() 
{
    char helpUrl[256];

    sprintf( helpUrl, "%s\\help\\nmapwin.chm::/Introduction.html", getenv( "NMAPDIR" ) );

	HWND hwnd =	HtmlHelp( NULL, helpUrl, HH_DISPLAY_TOPIC, NULL );
}

void CNmapwinDlg::OnSelchangeTab1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	if( IsWindow( m_scanPage.m_hWnd ) )
		m_scanPage.ShowWindow( SW_HIDE );
	if( IsWindow( m_discoverPage.m_hWnd ) )
		m_discoverPage.ShowWindow( SW_HIDE );
	if( IsWindow( m_optionsPage.m_hWnd ) )
		m_optionsPage.ShowWindow( SW_HIDE );
	if( IsWindow( m_filesPage.m_hWnd ) )
		m_filesPage.ShowWindow( SW_HIDE );
	if( IsWindow( m_timingPage.m_hWnd ) )
		m_timingPage.ShowWindow( SW_HIDE );
	if( IsWindow( m_servicePage.m_hWnd ) )
		m_servicePage.ShowWindow( SW_HIDE );
	if( IsWindow( m_windowsPage.m_hWnd ) )
		m_windowsPage.ShowWindow( SW_HIDE );

	switch( m_optionstab.GetCurSel() )
	{
	case 0:
		m_scanPage.SetVisible( &m_optionstab );
		break;
	case 1:
		m_discoverPage.SetVisible( &m_optionstab );
		break;
	case 2:
		m_optionsPage.SetVisible( &m_optionstab );
		break;
	case 3:
		m_timingPage.SetVisible( &m_optionstab );
		break;
	case 4:
		m_filesPage.SetVisible( &m_optionstab );
		break;
	case 5:
		m_servicePage.SetVisible( &m_optionstab );
		break;
	case 6:
		m_windowsPage.SetVisible( &m_optionstab );
		break;
	}
}

HBRUSH CNmapwinDlg::OnCtlColor( CDC* pDC, CWnd* pWnd, UINT nCtlColor )
{
	switch (nCtlColor) {

	  case CTLCOLOR_EDIT:
	  case CTLCOLOR_MSGBOX:
		  // Set color to green on black and return the background
		  // brush.
		  pDC->SetTextColor(RGB(0, 255, 0));
		  pDC->SetBkColor(RGB(0, 0, 0));
		  return (HBRUSH)(m_pEditBkBrush->GetSafeHandle());

	  default:
		  return CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	  }
}
