/* ------------------------------------------------------------------------ */
/*                                                                          */
/*  Copyright (C)                                                           */
/*                                                                          */
/*  This program is free software; you can redistribute it and/or modify    */
/*  it under the terms of the GNU General Public License as published by    */
/*  the Free Software Foundation; either version 2 of the License, or       */
/*  (at your option) any later version.                                     */
/*                                                                          */
/*  This program is distributed in the hope that it will be useful, but     */
/*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-    */
/*  ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General        */
/*  Public License for more details.                                        */
/*                                                                          */
/*  You should have received a copy of the GNU General Public License along */
/*  with this program; if not, write to the Free Software Foundation, Inc., */
/*  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                   */
/*                                                                          */
/* ------------------------------------------------------------------------ */
/*  $Author: vogje02 $ $Revision: 1.3 $ $Date: 2002/07/09 10:55:30 $      */
/* ------------------------------------------------------------------------ */

#include "stdafx.h"
#include "nmapwin.h"
#include "optionspage.h"

extern COptions* options;

/////////////////////////////////////////////////////////////////////////////
// COptionsPage property page

/**
 * Constructor
 */
COptionsPage::COptionsPage() : CPropertyPage(COptionsPage::IDD)
{
	//{{AFX_DATA_INIT(COptionsPage)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	init = false;
}

/**
 * Destructor
 */
COptionsPage::~COptionsPage()
{
}

void COptionsPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionsPage)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP	

	// Default settings
	if( !init ) {
		init = true;
		SetOptions();
	}
}

BEGIN_MESSAGE_MAP(COptionsPage, CPropertyPage)
	//{{AFX_MSG_MAP(COptionsPage)
	ON_BN_CLICKED(IDC_CHECK_11, OnCheck11)
	ON_BN_CLICKED(IDC_CHECK_12, OnCheck12)
	ON_BN_CLICKED(IDC_CHECK_13, OnCheck13)
	ON_BN_CLICKED(IDC_CHECK_14, OnCheck14)
	ON_BN_CLICKED(IDC_CHECK_15, OnCheck15)
	ON_BN_CLICKED(IDC_CHECK_16, OnCheck16)
	ON_BN_CLICKED(IDC_CHECK_17, OnCheck17)
	ON_BN_CLICKED(IDC_CHECK_18, OnCheck18)
	ON_BN_CLICKED(IDC_CHECK_21, OnCheck21)
	ON_BN_CLICKED(IDC_CHECK_31, OnCheck31)
	ON_BN_CLICKED(IDC_CHECK_32, OnCheck32)
	ON_BN_CLICKED(IDC_CHECK_33, OnCheck33)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/**
 * Puts the new values into the widgets
 */
void COptionsPage::SetOptions()
{
	if( init ) {
		if( options->fragB )
			CheckDlgButton( IDC_CHECK_11, BST_CHECKED );

		if( options->identB )
			CheckDlgButton( IDC_CHECK_12, BST_CHECKED );

		if( options->resolveAllB )
			CheckDlgButton( IDC_CHECK_13, BST_CHECKED );

		if( options->resolveNotB )
			CheckDlgButton( IDC_CHECK_14, BST_CHECKED );

		if( options->fastScanB )
			CheckDlgButton( IDC_CHECK_15, BST_CHECKED );

		if( options->osDetectionB )
			CheckDlgButton( IDC_CHECK_16, BST_CHECKED );

		if( options->randomHostB )
			CheckDlgButton( IDC_CHECK_17, BST_CHECKED );

		if( options->resumeB )
			CheckDlgButton( IDC_CHECK_18, BST_CHECKED );

		// Debug options
		if( options->debugB )
			CheckDlgButton( IDC_CHECK_31, BST_CHECKED );

		if( options->verboseB )
			CheckDlgButton( IDC_CHECK_32, BST_CHECKED );

		if( options->veryVerboseB )
			CheckDlgButton( IDC_CHECK_33, BST_CHECKED );

	}
}

// Sets the fake status bar, for returning message
// to the main window without wasting time on windows
// message handling.
void COptionsPage::SetStatusBar( CEdit* status )
{
	m_statusbar = status;
}

/////////////////////////////////////////////////////////////////////////////
// COptionsPage message handlers

void COptionsPage::BuildCommand()
{
	// General options
	options->fragB = IsDlgButtonChecked( IDC_CHECK_11 ) ? true : false;
	options->identB = IsDlgButtonChecked( IDC_CHECK_12 ) ? true : false;
	options->resolveAllB = IsDlgButtonChecked( IDC_CHECK_13 ) ? true : false;
	options->resolveNotB = IsDlgButtonChecked( IDC_CHECK_14 ) ? true : false;
	options->fastScanB = IsDlgButtonChecked( IDC_CHECK_15 ) ? true : false;
	options->osDetectionB = IsDlgButtonChecked( IDC_CHECK_16 ) ? true : false;
	options->randomHostB = IsDlgButtonChecked( IDC_CHECK_17 ) ? true : false;
	options->resumeB = IsDlgButtonChecked( IDC_CHECK_18 ) ? true : false;

	// Debug options
	options->debugB = IsDlgButtonChecked( IDC_CHECK_31 ) ? true : false;
	options->verboseB = IsDlgButtonChecked( IDC_CHECK_32 ) ? true : false;
	options->veryVerboseB = IsDlgButtonChecked( IDC_CHECK_33 ) ? true : false;

	char cmd[1024];
	options->GetCommand( cmd );
	m_statusbar->SetWindowText( cmd );
}

void COptionsPage::OnCheck11() 
{
	BuildCommand();	
}

void COptionsPage::OnCheck12() 
{
	BuildCommand();		
}

void COptionsPage::OnCheck13() 
{
	BuildCommand();		
}

void COptionsPage::OnCheck14() 
{
	BuildCommand();		
}

void COptionsPage::OnCheck15() 
{
	BuildCommand();		
}

void COptionsPage::OnCheck16() 
{
	BuildCommand();		
}

void COptionsPage::OnCheck17() 
{
	BuildCommand();		
}

void COptionsPage::OnCheck18() 
{
	BuildCommand();	
}

void COptionsPage::OnCheck21() 
{
	BuildCommand();		
}

void COptionsPage::OnCheck31() 
{
	BuildCommand();		
}

void COptionsPage::OnCheck32() 
{
	if( IsDlgButtonChecked( IDC_CHECK_33 ) )
		CheckDlgButton( IDC_CHECK_33, FALSE );
	BuildCommand();			
}

void COptionsPage::OnCheck33() 
{
	if( IsDlgButtonChecked( IDC_CHECK_32 ) )
		CheckDlgButton( IDC_CHECK_32, FALSE );
	BuildCommand();		
}

void COptionsPage::SetVisible( CTabCtrl* parent )
{
	if( !IsWindow( m_hWnd ) ) {
		Create( IDD_DIALOG_OPTIONS, parent );
	
		CRect rectParent;
		parent->GetWindowRect( rectParent );

		SetWindowPos( parent, 5, 25, rectParent.Width() - 10, rectParent.Height()-27, 
					  SWP_NOZORDER | SWP_NOACTIVATE );
	}

	// ?????? but works
	ShowWindow( SW_SHOW );
	//ShowWindow( SW_HIDE );
	//ShowWindow( SW_SHOW );
}
